	.importzp ST
	.import BSOUT
	.include "pet.inc"
       
CHROUT  = $ffd2          ; CHROUT is the address of the character output routine
GETIN   = $ffe4
CR      = $0d            ; PETSCII code for Carriage Return 
   


.segment "ZEROPAGE"

ptr_zp:	.res 2
spsave:	.res 1



.segment "INIT"
.segment "STARTUP"

Start:

	lda FNLEN
	pha					; Save FNLEN
	lda #14
	jsr BSOUT
	pla
	sta FNLEN			; Restore FNLEN

	tsx
	stx spsave          ; save the system stack ptr

	jsr main

	lda #0				; program return code
	sta ST				; BASIC status variable

	ldx spsave			; restore the stack pointer
	txs 

	rts					; return to BASIC

		
		
		
main:
		
	jsr clear_screen	
	
	ldx #<message
	ldy #>message
	jsr print_str
	
	lda #$0c		;keep graphics character set active
					;PET version of pest_init takes A contents to use in subsequent PCR writes
	

	jsr petplay_init
	
	lda #<music_data
	ldx #>music_data
	jsr petplay_start
	
loop_main:

	jsr wait_frame

	jsr GETIN
	beq loop_main

	jsr petplay_stop
	jsr wait_frame
	jsr petplay_done
	
	rts
	
	
	
clear_screen:

	lda #$93
	jmp CHROUT

	

print_str:

	stx <ptr_zp+0
	sty <ptr_zp+1
	ldy #0
:
	lda (ptr_zp),y
	beq :+
	jsr CHROUT
	iny
	bne :-
	inc <ptr_zp+1
	jmp :-
:
	rts

	

	
wait_frame:

	lda $99
:
	cmp $99
	beq :-
	
	rts
	

	
message:

	.byte "playing some music...", CR
	.byte 0
	
	
music_data:
	.include "music.s"

	.include "petplay.s"